#Sequence FM v.3 Copyright (c) 2017 JJ Posti <techtimejourney.net> 
#This program comes with ABSOLUTELY NO WARRANTY; 
#for details see: http://www.gnu.org/copyleft/gpl.html. 
#This is free software, and you are welcome to redistribute it under 
#GPL Version 2, June 1991")
#!/usr/bin/env python

from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
import os, sys, subprocess, getpass, shutil

class Main(QMainWindow):
    def __init__(self, *args, **kwargs):
        super(Main, self).__init__(*args, **kwargs)

#Title		
        self.setWindowTitle("Sequence FM v.3")
        self.resize(600, 480)

#Layouts      
        self.vertical = QVBoxLayout()

#Address bar
        self.address=QLineEdit()
        self.address.setText("/")
        self.address.setFixedSize(550, 40)        
        self.address.setAlignment(Qt.AlignCenter)
        self.address.returnPressed.connect(self.navigate)

#Toolbar
        self.toolbar=QToolBar()
        self.toolbar.addSeparator()
        self.toolbar.addWidget(self.address)
        self.addToolBar(self.toolbar)
        self.toolbar.setLayout(self.vertical)  
      
#Treeview setup        
        self.treeview = QTreeView(self)
        self.treeview.model = QFileSystemModel()
        self.path=self.address.text()
        self.path="/"
        self.treeview.model.setRootPath(self.path)

        self.treeview.setModel(self.treeview.model)
        self.treeview.setRootIndex(self.treeview.model.index(self.path))
        self.treeview.setColumnWidth(0, 200)     
        self.treeview.clicked.connect(self.on_treeview_clicked)
#Menu
        self.menu = self.menuBar().addMenu('File')        
#Menu actions 
#########################################################NEW DIR/FILE       
        self.clip_me = self.menu.addAction('Copy to clipboard')
        self.clip_me.triggered.connect(self.moving)
        
        self.open_me = self.menu.addAction('Open selected file with...')
        self.open_me.triggered.connect(self.opens_me)
        
        self.newdir1 = self.menu.addAction('Make a new directory')
        self.newdir1.triggered.connect(self.newdir)
        
        self.newfile1 = self.menu.addAction('Make a new text file')
        self.newfile1.triggered.connect(self.newfile)

        self.rename1 = self.menu.addAction('Rename object')
        self.rename1.triggered.connect(self.rename)
    
        self.sep1 = self.menu.addSeparator()
######################################################## TRASH AND DELETE
        self.trash1 = self.menu.addAction('Trash file/folder')
        self.trash1.triggered.connect(self.trash)

        self.for1 = self.menu.addAction('Delete Permanently')
        self.for1.triggered.connect(self.permanent)
        
        self.sep2 = self.menu.addSeparator()
#################################################################### MOVE/COPY/PASTE
        self.moving1 = self.menu.addAction('Select for moving/copying')
        self.moving1.triggered.connect(self.moving)

        self.pasting1 = self.menu.addAction('Paste a copy to location')
        self.pasting1.triggered.connect(self.pasting)

        self.actually1 = self.menu.addAction('Move a file or a folder to a location')
        self.actually1.triggered.connect(self.actually_moving)
        self.sep3 = self.menu.addSeparator()

        self.openar = self.menu.addAction('Open archive')
        self.openar.triggered.connect(self.rolleropen)

        self.compress = self.menu.addAction('Compress object')
        self.compress.triggered.connect(self.filecompress)
        
        self.extract = self.menu.addAction('Extract object')
        self.extract.triggered.connect(self.filextract)
#################################################################################ABOUT DIALOG
        self.about1 = self.menu.addAction('About')
        self.about1.triggered.connect(self.about)
#Layout                    
        self.vertical.addWidget(self.treeview)    
        self.setCentralWidget(self.treeview)

        self.setLayout(self.vertical)
        self.show()
###################################
#Right-Click menu
    def contextMenuEvent(self, event):
        self.menu = QMenu(self)
        
        self.clip_me = self.menu.addAction('Copy to clipboard')
        self.clip_me.triggered.connect(self.moving)
        
        self.open_me = self.menu.addAction('Open selected file with...')
        self.open_me.triggered.connect(self.opens_me)
        
        self.newdir1 = self.menu.addAction('Make a new directory')
        self.newdir1.triggered.connect(self.newdir)
        
        self.newfile1 = self.menu.addAction('Make a new text file')
        self.newfile1.triggered.connect(self.newfile)

        self.rename1 = self.menu.addAction('Rename object')
        self.rename1.triggered.connect(self.rename)

        self.sep1 = self.menu.addSeparator()
######################################################## TRASH AND DELETE
        self.trash1 = self.menu.addAction('Trash file/folder')
        self.trash1.triggered.connect(self.trash)

        self.for1 = self.menu.addAction('Delete Permanently')
        self.for1.triggered.connect(self.permanent)
        
        self.sep2 = self.menu.addSeparator()
#################################################################### MOVE/COPY/PASTE
        self.moving1 = self.menu.addAction('Select for moving/copying')
        self.moving1.triggered.connect(self.moving)

        self.pasting1 = self.menu.addAction('Paste a copy to location')
        self.pasting1.triggered.connect(self.pasting)

        self.actually1 = self.menu.addAction('Move a file or a folder to a location')
        self.actually1.triggered.connect(self.actually_moving)
        self.sep3 = self.menu.addSeparator()

        self.openar = self.menu.addAction('Open archive')
        self.openar.triggered.connect(self.rolleropen)

        self.compress = self.menu.addAction('Compress object')
        self.compress.triggered.connect(self.filecompress)
        
        self.extract = self.menu.addAction('Extract object')
        self.extract.triggered.connect(self.filextract)


#################################################################################ABOUT DIALOG
        self.about1 = self.menu.addAction('About')
        self.about1.triggered.connect(self.about)
        
# add other required actions
        self.menu.popup(QtGui.QCursor.pos())

#About messagebox
    def about(self):
        buttonReply = QMessageBox.question(self, 'Sequence FM v.3 Copyright (c) 2017 JJ Posti <techtimejourney.net>', "Sequence FM is is a python file manager, which ports the features of Crosslinker FM series to QT5 - and adds many things along way.The program comes with ABSOLUTELY NO WARRANTY  for details see: http://www.gnu.org/copyleft/gpl.html. This is free software, and you are welcome to redistribute it under GPL Version 2, June 1991. Tip.Holding Shift key activates 'Open file with Sequence FM defaults' mode.", QMessageBox.Ok )
        if buttonReply == QMessageBox.Ok:
            print('Ok clicked, messagebox closed.')
###########################################            
###Double left-click function        
    @QtCore.pyqtSlot(QtCore.QModelIndex)
    def on_treeview_clicked(self, index):
        global indexItem
        indexItem = self.treeview.model.index(index.row(), 0, index.parent())

        # path or filename selected
        global filename
        filename = self.treeview.model.fileName(indexItem)
        # full path/filename selected
        global filepath
        filepath = self.treeview.model.filePath(indexItem)
        self.address.setText(filepath)
        print(filename)
        print(filepath)
        if qApp.keyboardModifiers() & Qt.ShiftModifier:        
            if filepath.endswith("pdf"):
                subprocess.Popen(['qpdfview', filepath])
            elif filepath.endswith("abw"):
                subprocess.Popen(['abiword', filepath])
            elif filepath.endswith("odt"):
                subprocess.Popen(['libreoffice', filepath])
            elif filepath.endswith("odp"):
                subprocess.Popen(['libreoffice', filepath])    
            elif filepath.endswith("txt"):
                subprocess.Popen(['geany', filepath])
            elif filepath.endswith("png"):
                subprocess.Popen(['feh', filepath])
            elif filepath.endswith("jpg"):
                subprocess.Popen(['feh', filepath])
            elif filepath.endswith("ogg"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("mp3"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("mp4"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("avi"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("midi"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("xcf"):
                subprocess.Popen(['gimp', filepath])
            elif filepath.endswith("mpg"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("mp2"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("flw"):
                subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("swf"):
                 subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("m4v"):
                 subprocess.Popen(['vlc', filepath])
            elif filepath.endswith("py"):
                 subprocess.Popen(['geany', filepath])
            else:
                 subprocess.Popen(['geany', filepath])              
                  
            return True # event has been handled            
#Navigation
    def navigate(self):
        self.treeview.model = QFileSystemModel()
        self.path=self.address.text()
        self.treeview.model.setRootPath(self.path)
        self.treeview.setModel(self.treeview.model)
        self.treeview.setRootIndex(self.treeview.model.index(self.path))
        self.treeview.setColumnWidth(0, 200)            	 
#######################################################################            
######################

# Select Moving/Copying for files and folders		
    def moving(self, event):        
        global ax
        ax=filepath
        print ax
        clip = QApplication.clipboard()
        clip.clear(mode=clip.Clipboard )
        clip.setText(ax, mode=clip.Clipboard)

#Copy to a path
    def pasting(self):
        reply = QMessageBox.question(None, 'Message',
            "Copy a file/folder here? Content with similar name will be overwritten", QMessageBox.Yes | 
            QMessageBox.No, QMessageBox.No)
        if reply == QMessageBox.Yes:
            os.chdir(filepath)
            print ax
            subprocess.Popen(['cp', '-r', ax , filepath])              
        if reply == QMessageBox.No:            
            pass 

#Actually move to a path
    def actually_moving(self):
        reply = QMessageBox.question(None, 'Message',
            "Move a file/folder here? Content with similar name will be overwritten", QMessageBox.Yes | 
            QMessageBox.No, QMessageBox.No)
        if reply == QMessageBox.Yes:
            os.chdir(filepath)
            print ax
            subprocess.Popen(['mv', ax , filepath])    
     
        if reply == QMessageBox.No:            
            pass
            
#Rename in current path
    def rename(self):
        text, ok = QInputDialog.getText(self, 'Rename an object', ' \n Remember to include the extension as well (file example:foo.txt - if in any doubt CANCEL NOW. ')
        if ok:
            print text
            print "Now:", filepath
            renamepath=os.path.dirname(filepath)
            print "Rename pathway:", renamepath
            new_entry= renamepath + '/' + text
            print "New object location after renaming is:", new_entry
            subprocess.Popen(['mv', filepath , new_entry]) 
            
#Open With program...
    def opens_me(self):
        text, ok = QInputDialog.getText(self, 'Open with a program', ' \n Type the name of the program, which you want to use. ')
        if ok:
            print text
            subprocess.Popen([text , filepath])                                                                        
#########################
#TRASH FUNCTION
#############################
    def trash(self, event):        
        reply = QMessageBox.question(None, 'Message',
            "Move to trash? If a content with same name exists on trash, then nothing will happen here.", QMessageBox.Yes | 
            QMessageBox.No, QMessageBox.No)

        if reply == QMessageBox.Yes:
            name=getpass.getuser()
            uhome="/home/"
            trash="/trash"
            combine1=uhome + name
            os.chdir(combine1)            
            
            if os.path.exists('trash'):
                name=getpass.getuser()
                uhome="/home/"
                trash="/trash"
                combine1=uhome + name 
                os.chdir(combine1)            
                combinex=uhome + name + trash
                for files in filepath:
                    shutil.move(filepath, combinex)
		     
            else:
                makefolder=os.makedirs('trash')
        
                name=getpass.getuser()
                uhome="/home/"
                trash="/trash"
                combine1=uhome + name 
                os.chdir(combine1)            
                combinex=uhome + name + trash
                for files in filepath:
		            shutil.move(filepath, combinex)
   
        if reply == QMessageBox.No:            
            pass        
    
#Remove permanently
    def permanent(self, event):        
        reply = QMessageBox.question(None, 'Message',
            "Delete permanently? File/Folder will be gone forever.", QMessageBox.Yes | 
            QMessageBox.No, QMessageBox.No)

        if reply == QMessageBox.Yes:
            subprocess.Popen(['rm' , '-r', filepath])   
        if reply == QMessageBox.No:            
            pass              
##############################
#CREATE OBJECT FUNCTIONS
#################################
#File-roller integrations
    def filextract(self,widget):
		subprocess.Popen(['file-roller', filepath , '--extract']) 
		
    def filecompress(self,widget):
		subprocess.Popen(['file-roller', '-d', '--add', filepath]) 
				
    def rolleropen(self,widget):
		subprocess.Popen(['file-roller', filepath]) 

#Make new directory
    def newdir(self,widget):
		os.chdir(filepath)
		makefolder=os.makedirs('Newfolder')
		print os.getcwd()
		makefolder           

#Make new empty text file
    def newfile(self,widget):
        os.chdir(filepath)
        newtext=os.mknod('Newtext.txt')
        print os.getcwd()
        newtext
        
if __name__ == '__main__':
    app = QApplication(sys.argv)
    window = Main()
    window.show() 
    sys.exit(app.exec_())
